# Copyright (c) 2000-2012, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

%bcond_without maven
%bcond_without repolib

%define reltag _redhat_1
%define namedreltag -redhat-1
%global namedversion %{version}%{?namedreltag}

%define section free

Name:           glassfish-jsf
Version:        2.1.7
Release:        1%{?reltag}.4%{?dist}
Epoch:          0
Summary:        GlassFish JSF
License:        CDDL
Group:          Development/Java
URL:            https://javaserverfaces.dev.java.net/
#Source0:        http://java.net/projects/javaserverfaces/downloads/download/release/mojarra-2.0.4-FCS-source.zip

#svn export https://svn.java.net/svn/mojarra~svn/tags/2.1.7/ mojarra-2.1.7
#Exported revision 9785.
#tar zcf mojarra-2.1.7.tar.gz mojarra-2.1.7/
Source0:        mojarra-2.1.7.tar.gz

Source5:        http://repo1.maven.org/maven2/com/sun/faces/jsf-api/2.1.7/jsf-api-2.1.7.pom
Source6:        http://repo1.maven.org/maven2/com/sun/faces/jsf-impl/2.1.7/jsf-impl-2.1.7.pom
Source7:        jsf-api-2.1.7-vman.pom
Source8:        jsf-impl-2.1.7-vman.pom
Patch0:         mojarra-2.1.7-build.patch

#git clone git://github.com/jboss/mojarra.git
#cd mojarra
#git checkout remotes/origin/2.1.7-jbossorg-2
#HEAD is now at 00657a6... Need to include js files in the impl.  Bumping to jsf-impl-2.1.7-jbossorg-2
#rm -rf .git*
#cd ..
#diff -uNr mojarra-2.1.7 mojarra > ../mojarra-2.1.7-jbossorg.patch
Patch2:         mojarra-2.1.7-jbossorg.patch

Requires(post): jpackage-utils
Requires(postun): jpackage-utils
Requires:       jpackage-utils
BuildRequires:  ant
BuildRequires:  ant-contrib
BuildRequires:  aqute-bndlib
BuildRequires:  el_api
BuildRequires:  glassfish-jstl
BuildRequires:  groovy15
BuildRequires:  hibernate-beanvalidation-api
BuildRequires:  jakarta-commons-digester
BuildRequires:  apache-commons-logging
BuildRequires:  jboss-servlet-api_3.0_spec
BuildRequires:  jpackage-utils
BuildRequires:  tomcat6-jsp-2.1-api
BuildRequires:  yuicompressor
BuildRequires:  tlddoc
BuildRequires:  jboss-parent
BuildRequires:  jboss-component-management

BuildRequires:  maven2 >= 0:2.0.7
BuildRequires:  maven2-plugin-antrun
BuildRequires:  maven2-plugin-assembly
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven-ant-tasks
BuildRequires:  maven2-plugin-resources
BuildRequires:  maven2-plugin-site
BuildRequires:  maven2-plugin-source
BuildRequires:  maven2-plugin-release
BuildRequires:  maven-surefire-plugin
BuildRequires:  maven-jxr
BuildRequires:  maven-release
BuildRequires:  maven-deploy-plugin

BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
The JSF 2.0 implementation. NB: We've omitted the classes
Jetty6InjectionProvider and GlassFishInjectionProvider from the
package com.sun.faces.vendor.

%if %with repolib
%package repolib
Summary:        Artifacts to be uploaded to a repository library
Group:          Development/Libraries/Java

%description repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio.
%endif

%package javadoc
Summary:        Javadoc for %{name}
Group:          Development/Documentation
Requires:       jpackage-utils

%description javadoc
%{summary}.

%prep
%setup -q -n mojarra-%{version}
%patch2 -p1 -b .sav2
%patch0 -p1 -b .sav0
#%patch1 -p0 -b .sav1

# XXX: keep bnd-0.0.249.jar and injectionproviders.jar for build
%{_bindir}/find -type f \( -name "*.jar" -and -not \( -name bnd-0.0.249.jar -or -name injectionproviders.jar \) \) | %{_bindir}/xargs -t %{__rm}

%{__cp} -p build.properties.glassfish build.properties

#%{__rm} -r jsf-api/build/generate jsf-ri/build/generate

%build
export MAVEN_REPO_LOCAL=$(pwd)/.m2/repository
mkdir -p $MAVEN_REPO_LOCAL

export CLASSPATH=`%{_bindir}/build-classpath tomcat6-jsp-2.1-api commons-logging el_api jboss-servlet-api_3.0_spec commons-digester groovy15 maven-ant-tasks ant-contrib commons-collections glassfish-jstl validation-api commons-beanutils glassfish-jstl yuicompressor`:`pwd`/common/lib/bnd-0.0.249.jar
export OPT_JAR_LIST=:

#NOTE: the generated jsf-tools version is 2.1.8
%{ant} -v   -Dmvn.cmd=mvn-jpp \
            -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
            -Djsf-tools.jar=`pwd`/jsf-tools/target/jsf-tools-2.1.8-SNAPSHOT.jar \
            -Dbuild.sysclasspath=first \
            -Dbuild.source=true \
            -Djsf.build.home=`pwd` \
            -Dyuicompressor.jar=`build-classpath yuicompressor` \
            -Dtlddoc.jar=`build-classpath tlddoc` \
            -Dimpl.version=%{namedversion} dist

%if 0
# generate javadocsfor jsf-ri
pushd jsf-ri
%{ant} -v   -Dmvn.cmd=mvn-jpp \
            -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
            -Djsf-tools.jar=`pwd`/jsf-tools/target/jsf-tools-2.1.8-SNAPSHOT.jar \
            -Dbuild.sysclasspath=first \
            -Dbuild.source=true \
            -Djsf.build.home=`pwd` \
            -Dyuicompressor.jar=`build-classpath yuicompressor` \
            -Dtlddoc.jar=`build-classpath tlddoc` \
            -Dimpl.version=%{namedversion} \
            javadocs
popd

# generate javadocs for jsf-api
pushd jsf-api
%{ant} -v   -Dmvn.cmd=mvn-jpp \
            -Dmaven.repo.local=$MAVEN_REPO_LOCAL \
            -Djsf-tools.jar=`pwd`/jsf-tools/target/jsf-tools-2.1.8-SNAPSHOT.jar \
            -Dbuild.sysclasspath=first \
            -Dbuild.source=true \
            -Djsf.build.home=`pwd` \
            -Dyuicompressor.jar=`build-classpath yuicompressor` \
            -Dtlddoc.jar=`build-classpath tlddoc` \
            -Dimpl.version=%{namedversion} \
            javadocs
popd
%endif

%install
%{__rm} -rf %{buildroot}

ls -lR jsf-demo

unzip -o jsf-demo/dist/docs/mojarra-%{version}-redhat-1-documentation.zip -d jsf-demo/dist/docs

#jars

ls -lR jsf-api
ls -lR jsf-ri

%{__mkdir_p} %{buildroot}%{_javadir}
%{__cp} -p jsf-api/build/lib/jsf-api-intermediate.jar %{buildroot}%{_javadir}/jsf-api-%{namedversion}.jar
%{__cp} -p jsf-ri/build/lib/javax.faces.jar %{buildroot}%{_javadir}/jsf-impl-%{namedversion}.jar

#sources
%{__cp} -p dist/glassfish-jsf-%{version}-redhat-1-src.jar %{buildroot}%{_javadir}/glassfish-jsf-%{namedversion}-sources.jar

pushd %{buildroot}%{_javadir}
%{__ln_s} jsf-api-%{namedversion}.jar jsf-api.jar
%{__ln_s} jsf-impl-%{namedversion}.jar jsf-impl.jar
%{__ln_s} glassfish-jsf-%{namedversion}-sources.jar glassfish-jsf-sources.jar
popd

# poms
%{__mkdir_p} %{buildroot}%{_datadir}/maven2/poms
%{__cp} -p %{SOURCE7} %{buildroot}%{_datadir}/maven2/poms/JPP-jsf-api.pom
%add_to_maven_depmap com.sun.faces jsf-api %{namedversion} JPP jsf-api
%{__cp} -p %{SOURCE8} %{buildroot}%{_datadir}/maven2/poms/JPP-jsf-impl.pom
%add_to_maven_depmap com.sun.faces jsf-impl %{namedversion} JPP jsf-impl

# javadoc
#%{__mkdir_p} %{buildroot}%{_javadocdir}/jsf-api-%{namedversion}
#%{__mkdir_p} %{buildroot}%{_javadocdir}/jsf-impl-%{namedversion}
#%{__cp} -pr jsf-api/build/javadocs/* %{buildroot}%{_javadocdir}/jsf-api-%{namedversion}
#%{__cp} -pr jsf-ri/build/javadocs/* %{buildroot}%{_javadocdir}/jsf-impl-%{namedversion}
#%{__ln_s} jsf-api-%{namedversion} %{buildroot}%{_javadocdir}/jsf-api
#%{__ln_s} jsf-impl-%{namedversion} %{buildroot}%{_javadocdir}/jsf-impl
%{__mkdir_p} %{buildroot}%{_javadocdir}/glassfish-jsf-%{namedversion}
%{__cp} -pr jsf-demo/dist/docs/javadocs/* %{buildroot}%{_javadocdir}/glassfish-jsf-%{namedversion}
%{__ln_s} glassfish-jsf-%{namedversion} %{buildroot}%{_javadocdir}/glassfish-jsf

%if %with repolib
export MAVEN_REPO_LOCAL=`pwd`/.m2/repository
export URL=file://%{buildroot}%{_javadir}/repository.jboss.com/maven2-brew
%{_bindir}/mvn-jpp deploy:deploy-file \
    -Dmaven.repo.local=${MAVEN_REPO_LOCAL} \
    -Dversion=%{namedversion} \
    -DpomFile=%{buildroot}%{_datadir}/maven2/poms/JPP-jsf-api.pom \
    -Dfile=%{buildroot}%{_javadir}/jsf-api-%{namedversion}.jar -Durl=${URL} \
    -DrepositoryId=oss-releases
%{_bindir}/mvn-jpp deploy:deploy-file \
    -Dmaven.repo.local=${MAVEN_REPO_LOCAL} \
    -Dversion=%{namedversion} \
    -DpomFile=%{buildroot}%{_datadir}/maven2/poms/JPP-jsf-impl.pom \
    -Dfile=%{buildroot}%{_javadir}/jsf-impl-%{namedversion}.jar \
    -Durl=${URL} -DrepositoryId=oss-releases
%endif

%post
%update_maven_depmap 

%postun
%update_maven_depmap

%clean
%{__rm} -rf %{buildroot}

%files
%defattr(0644,root,root,0755)
%{_javadir}*/jsf-api-%{namedversion}.jar
%{_javadir}*/jsf-api.jar
%{_javadir}*/jsf-impl-%{namedversion}.jar
%{_javadir}*/jsf-impl.jar
%{_datadir}/maven2/poms/JPP-jsf-api.pom
%{_datadir}/maven2/poms/JPP-jsf-impl.pom

%{_javadir}*/glassfish-jsf-sources.jar
%{_javadir}*/glassfish-jsf-%{namedversion}-sources.jar

%{_mavendepmapfragdir}/%{name}

%files javadoc
%defattr(0644,root,root,0755)
#%{_javadocdir}/jsf-api-%{namedversion}
#%{_javadocdir}/jsf-api
#%{_javadocdir}/jsf-impl-%{namedversion}
#%{_javadocdir}/jsf-impl
%{_javadocdir}/glassfish-jsf-%{namedversion}
%{_javadocdir}/glassfish-jsf

%if %with repolib
%files repolib
%defattr(0644,root,root,0755)
%dir %{_javadir}*
%exclude %dir %{_javadocdir}
%{_javadir}*/repository.jboss.com
%endif

%changelog
* Tue Apr 10 2012 Yong Yang <yyang@redhat.com> 0:2.1.7-1_redhat_1.4
- Fix jsf-impl pom

* Thu Mar 29 2012 Yong Yang <yyang@redhat.com> 0:2.1.7-1_redhat_1.3
- Fix pom location in -repolib

* Thu Mar 29 2012 Yong Yang <yyang@redhat.com> 0:2.1.7-1_redhat_1.2
- Fix pom location in -repolib

* Thu Mar 29 2012 Yong Yang <yyang@redhat.com> 0:2.1.7-1_redhat_1.1
- Upgrade to 2.1.7

* Mon Mar 26 2012 Fernando Nasser <fnasser@redhat.com> - 0:2.1.5-2_redhat_1.1
- Rebuild using cache signing

* Fri Feb 17 2012 Yong Yang <yyang@redhat.com> 0:2.1.5-2_redhat_1
- Update patch to fix JBPAPP-8143, remove javax.faces from jsf-impl.jar

* Wed Dec 14 2011 Yong Yang <yyang@redhat.com> 0:2.1.5-1_redhat_1
- Upgrade to 2.1.5

* Thu Nov 24 2011 Yong Yang <yyang@redhat.com> 0:2.1.3-1_b02_redhat_1
- Upgrade to 2.1.3-b02
- Apply jbossorg changes by patch

* Fri Oct 21 2011 David Walluck <dwalluck@redhat.com> 0:2.0.4-9_b09_redhat_1
- remove pre-generated files before building
- BuildRequires: tlddoc
- update hibernate-beanvalidation-api location

* Wed Oct 19 2011 David Walluck <dwalluck@redhat.com> 0:2.0.4-8_b09_redhat_1
- fix bad depmaps
- fix javadoc dir names and versions
- fix repolib to not own javadoc dir
- remove sources jars since we cannot use zips in place of sources jars

* Wed Sep 28 2011 Yong Yang<yyang@redhat.com> 0:2.0.4-7_b09_redhat_1
- Add sources and javadocs
- Deploy to mead repo with -redhat-1
- Set impl.version=2.0.4-b09-redhat-1, so the MANIFEST has same implementaion-version as POM

* Tue Sep 27 2011 Yong Yang<yyang@redhat.com> 0:2.0.4-6_b09_redhat_1
- Clean spec file

* Tue Sep 27 2011 Yong Yang<yyang@redhat.com> 0:2.0.4-5_b09_redhat_1
- BR:  yuicompressor
- Keep injectionproviders.jar also
- Use ant default target main because of no jsf-demo

* Mon Sep 26 2011 David Walluck <dwalluck@redhat.com> 0:2.0.4-4_b09_redhat_1
- update sources

* Mon Sep 26 2011 David Walluck <dwalluck@redhat.com> 0:2.0.4-3_b09_redhat_1
- build fixes

* Mon Sep 19 2011 Yong Yang <yyang@redhat.com> - 0:2.0.4-2.b09_redhat_1
- Build for Werewolf

* Thu Jun 9 2011 Yong Yang <yyang@redhat.com> - 0:2.0.4-1
- Upgrade to 2.0.4

* Wed Feb 9 2011 Yiqiao Wang <yiwang@redhat.com> - 0:1.2_13-3.1.4
- Add %%update_maven_depmap in %%post and %%postun

* Mon Jan 17 2011 Yiqiao Wang <yiwang@redhat.com> - 0:1.2_13-3.1.3
- Fix upload.sh

* Thu Dec 16 2010 Yiqiao Wang <yiwang@redhat.com> - 0:1.2_13-3.1.2
- Build with Maven 2.2.1
- Add upload.sh to repolib
- Add poms to repolib
- Fix %%files for signed jars
- Add content of maven2-brew, add BR maven-deploy-plugin

* Mon May 17 2010 Martha Benitez <mbenitez@redhat.com> - 0:1.2_13-3.1.1
- rebuilt

* Tue Apr 20 2010 Luiz Barreiros <gbarreir@redhat.com> 0:1.2_13-4
- Rebuild

* Thu Aug 06 2009 Fernando Nasser <fnasser@redhat.com> 0:1.2_13-3
- Replace "BR jbossweb" with "BR tomcat6", drop circular deps
- BR:  geronimo-el-1.0-api
- Update glassfish-jsf-build.xml, use geronimo's el-api && annotation instead
- Add el-api to deppath

* Thu Aug 06 2009 Fernando Nasser <fnasser@redhat.com> 0:1.2_13-2
- Add updated overlay file

* Thu Aug 06 2009 Fernando Nasser <fnasser@redhat.com> 0:1.2_13-1
- Upgrade to 1.2_13
- Remove overlay

* Tue Jun 23 2009 Yong Yang <yyang@redhat.com> 0:1.2_10-0jpp.ep1.6
- BR geronimo-annotation-1.0-api

* Tue Nov 25 2008 Yong Yang <yyang@redhat.com> 0:1.2_10-0jpp.ep1.5
- BR java 1.5

* Fri Nov 21 2008 Yong Yang <yyang@redhat.com> 0:1.2_10-0jpp.ep1.4
- Bump version number

* Fri Nov 21 2008 Yong Yang <yyang@redhat.com> 0:1.2_10-0jpp.ep1.3
- BR groovy15 instead of bundling its jar

* Wed Nov 05 2008 Yong Yang <yyang@redhat.com> 0:1.2_10-0jpp.ep1.2
- updating to 1.2_10

* Thu Jul 24 2008 Jon Prindiville <jprindiv@redhat.com> 0:1.2_09-0jpp.ep1.2
- Fixing version tag

* Thu Jul 24 2008 Jon Prindiville <jprindiv@redhat.com> 0:1.2_09-0jpp.ep1.1
- Updating to 1.2_09

* Mon Jul 21 2008 Jon Prindiville <jprindiv@redhat.com> 0:1.2_08-0jpp.ep1.4
- Moving from sun-jsf to glassfish/jsf (in repolib)

* Thu Apr 24 2008 Jon Prindiville <jprindiv@redhat.com> 0:1.2_08-0jpp.ep1.3
- Output JARs now have proper MANIFEST.MFs

* Wed Mar 19 2008 Jon Prindiville <jprindiv@redhat.com> 0:1.2_08-0jpp.ep1.1
- Upgrading to 1.2_08

* Fri Nov 30 2007 Jon Prindiville <jprindiv@redhat.com> 0:1.2_04-1.p02.0jpp.ep1.18
- Adding a bunch of Apache commons source to compile in with the -impl stuff

* Thu Nov 29 2007 Jon Prindiville <jprindiv@redhat.com> 0:1.2_04-1.p02.0jpp.ep1.17
- Adding an "overlay" JAR containing all of the non-classfiles which our -impl
  JAR is missing when compared to Sun's (see also, note at Source1)
- Adding the overlay jar and -build.xml to %%{repodirsrc}

* Wed Nov 28 2007 Jon Prindiville <jprindiv@redhat.com> 0:1.2_04-1.p02.0jpp.ep1.16
- Adding jbossweb's annotations-api.jar to the impl's classpath

* Wed Nov 28 2007 Jon Prindiville <jprindiv@redhat.com> 0:1.2_04-1.p02.0jpp.ep1.15
- Fixing mistakely clobbered @API-DIR@ and @IMPL-DIR@ targets in -build.xml

* Wed Nov 28 2007 Jon Prindiville <jprindiv@redhat.com> 0:1.2_04-1.p02.0jpp.ep1.14
- First complete build

* Fri Nov 23 2007 Fernando Nasser <fnasser@redhat.com> 0:1.2_04-1.p02.0jpp.ep1.13
- Revert to sun-jaf name to please buildmagic

* Fri Nov 23 2007 Jon Prindiville <jprindiv@redhat.com> 0:1.2_04-1.p02.0jpp.ep1.12
- Added -brew suffix.

* Fri Nov 23 2007 Jon Prindiville <jprindiv@redhat.com> 0:1.2_04-1.p02.0jpp.ep1.11
- %%{release} twiddling (to appease the packaging gods)

* Fri Nov 23 2007 Jon Prindiville <jprindiv@redhat.com> 0:1.2_04-0jpp.ep1.11.p02
- Fixed build.xml path confusion.

* Fri Nov 23 2007 Jon Prindiville <jprindiv@redhat.com> 0:1.2_04-0jpp.ep1.10.p02
- Brain not work good today. BuildRequiring ant.

* Fri Nov 23 2007 Jon Prindiville <jprindiv@redhat.com> 0:1.2_04-0jpp.ep1.9.p02
- Fixed 'make new-source's omission of the jsf-impl JAR from sources

* Fri Nov 23 2007 Jon Prindiville <jprindiv@redhat.com> 0:1.2_04-0jpp.ep1.8.p02
- Uploaded new (non-broken!) version of Source0

* Fri Nov 23 2007 Jon Prindiville <jprindiv@redhat.com> 0:1.2_04-0jpp.ep1.7.p02
- Corrected %%install section, and -impl's %%setup

* Fri Nov 23 2007 Jon Prindiville <jprindiv@redhat.com> 0:1.2_04-0jpp.ep1.6.p02
- Unbreaking the references to the ant buildfile

* Fri Nov 23 2007 Jon Prindiville <jprindiv@redhat.com> 0:1.2_04-0jpp.ep1.5.p02
- Using ant rather than inlining the build in the specfile

* Fri Nov 23 2007 Jon Prindiville <jprindiv@redhat.com> 0:1.2_04-0jpp.ep1.4.p02
- Changed -api's javac invocation

* Fri Nov 23 2007 Jon Prindiville <jprindiv@redhat.com> 0:1.2_04-0jpp.ep1.3.p02
- Added -api's sources to its classpath

* Thu Nov 22 2007 Jon Prindiville <jprindiv@redhat.com> 0:1.2_04-0jpp.ep1.2.p02
- Removed version specification from BR: glassfish-jstl

* Thu Nov 22 2007 Jon Prindiville <jprindiv@redhat.com> 0:1.2_04-0jpp.ep1.1.p02
- First release. The -api JAR is building, the -impl JAR is not (yet).
